# Different random forest interpretation methods

## 1. Confidence based on tree variance
> Normally the prediction is just the average, this is variance of the trees.

## 2. Feature importance
*How?*
- Intuition: Take each feature and shuffle the values in the feature and check how the prediction change
  - If very different, it is important
  - Otherwise, it is not that important
- Quantify:
  - Take the differnce in R^2 or other metric score and compare that output.
  - Don't need to retain, but rondamly shuffle the whole column.

*Would all importances sum to one?*
Not sure.

There are two ways for doing feature importance:
1. Shuffling the columns one at a time
2. Doing tree interpreter for every rwo and adding them up

## 3. Partial dependence

It is to help understand how it change the objective with changing certain lever.

*How to calculate?*
- Pass every single value of that column/feature, and leave other columns whatever they are.
- Pass the data through the existing random forest. **NO need to retrain.**
- Then we could take the average one all the prediction to see what is the relationship between certain feature and the prediction.

*Why it works?*
Intuition, it is more likely answer the question: *what is the average/common of ...*

*Potential problem*
- Problem: Average usually would hide the fact that the totally different relationships.
- Solution: plot the median via cluster analysis

*How to define importance*
Important means it is a lever (that can change), how much it could contribute to the prediction.

*Does it need to do pairwise shuffling for every combination of two features?*
No, computation will be very expensive.

## 4. Tree interpreter
> Tree interpreter tells us the contributions for a particular row based on the difference in the tree. 

> It is more like feature importance, but feature importance is for complete random forest model, and this tree interpreter is for feature importance for particular observation. 

## 5. Extrapolation

## 6. Interaction importance
Interaction means appears on the same path through a tree.

## Reference
- https://medium.com/@hiromi_suenaga/machine-learning-1-lesson-6-14bbb8180d49