# Drivetrain Approach

Goal of drivetrain approach: Data is not just to generate mode data (in the form of predictions), but to preduce actionable outcomes.

There are four steps to build the data products:
1. **Define a clear objective**
2. **Levers (what inputs can we control)**
3. **Data (what data can collect)**
4. **Models (how the levers inflence the objective)**

**Four Steps**
![Four steps](http://cdn.oreilly.com/radar/images/posts/0312-1-drivetrain-approach-lg.png)

**Model Assembly line**
![Model Assembly line](http://cdn.oreilly.com/radar/images/posts/0312-2-drivetrain-step4-lg.png)

## 1. Objective

The objective is something that directly the company or org actually wants.

## 2. Levers

The levers is what the organization can do to actually drive the objective. It is to specify what inputs of the system we could control, which is also the way we could influence the final output. It is what you can try to achieve the objective. Examples:
- Objective: reduce the number of customers leaving
- Levers:
  - Free gifts
  - Discount etc.

## 3. Data

What the data does the org could possibly help them to set that lever to achieve the objective. We need to know what data we can get.

## 4. Modeles

The precondition to start modeling is:
- Understand the objective
- Understand the available levers
- What data we already have, what additional data we will need to collect

Models will take both levers and any uncontrollable variables as their inputs. Outputs will be combined to predict the final state for our objective.

The models here is more like a simulation model instead of a predictive model. Generally, the predictive models could be feed into the simulation model, but should be think about how they work together.

Most of the applications are not largely about the predictive model but about interpretaion, which is moure about understanding what happens.
- Use random forest model feature importance to tell what make a difference
- Then use the partial dependence to build the simulation model to simulate what would happen if we did that change

The simulation model is about two things: predict the churn, and optimize the gain/profit.

# Cases study

https://github.com/lzl7/design 

## Reference
- [Designing great data products: the drivetrain approach: A four-step process for building data products](https://www.oreilly.com/radar/drivetrain-approach-data-products/)
- https://medium.com/@hiromi_suenaga/machine-learning-1-lesson-6-14bbb8180d49
