The repository to store all the machine learning related materials.

# Notes
* [Machine learning related concepts](Topics/machine-learning-concepts.md)

# Learning Resources
Collection of reading resources that are interesting or very helpful for machine learning.

## Machine Learning 101
- [Machine learning for humans](https://medium.com/machine-learning-for-humans/why-machine-learning-matters-6164faf1df12) Easy to understanding and good for entry-level learners.
- [Machine learning is fun](https://www.machinelearningisfun.com/) Great reading resource for the entry-level learners
- Machine learning visualization
   - [A visual introduction to machine leanring](http://www.r2d3.us/visual-intro-to-machine-learning-part-1/)
   - [CNN visualization](https://poloclub.github.io/cnn-explainer/)

## Machine Learning 201
- [Machine learning by Andrew Ng, Standford University](https://www.coursera.org/learn/machine-learning) Great machine learning starting resources
- * [Machine learning (HUng-yi Lee, NTU)](https://www.youtube.com/watch?v=CXgbekl66jc&list=PLJV_el3uVTsPy9oCRY30oBPNLCo89yu49) Very great learning course. Professor Lee is humor and the introduction for the concepts/formula deductions are very easy to understand. You could lean how machine learning works, why it works.
    * More machine learning courses: http://speech.ee.ntu.edu.tw/~tlkagk/courses.html
- [Stanford's RNN class](http://cs224d.stanford.edu/), [Youtube](https://www.youtube.com/watch?v=OQQ-W_63UgQ&list=PL3FW7Lu3i5Jsnh1rnUwq_TcylNr7EkRe6)
- [Stanford's CNN class](http://cs231n.stanford.edu/)
- [Reinforcement Learning](https://www.davidsilver.uk/teaching/)
- [FastAI online courses](https://www.fast.ai/), FastAI has a lot of great online courses and the courses are very focusing on the practice. Great resources to hand on.
- [The matrix calculus you need for deep learning](https://explained.ai/matrix-calculus/)

## Machine learning in practice
- [Rules of Machine learning, Martin Zinkevich](http://martin.zinkevich.org/rules_of_ml/rules_of_ml.pdf)
- [Writing code for NLP Research](https://github.com/allenai/writing-code-for-nlp-research-emnlp2018/blob/master/writing_code_for_nlp_research.pdf)
- [Learning how to learn deep learning](https://evilmartians.com/chronicles/learning-how-to-learn-deep-learning)


## Books
* [Deep Learning Book](https://www.deeplearningbook.org/) Deep learning book authored by Ian Goodfellow, Yoshua Bengio and Aaron Courville
* [Neural Networks and Deep Learning](http://neuralnetworksanddeeplearning.com/) This book teaches the deep learning concepts with great detail examples.
* [Deep Learning with PyTorch book](https://github.com/borninfreedom/DeepLearning/blob/master/Books/Deep-Learning-with-PyTorch.pdf)

## Academic Sources
* https://openreview.net/, able to see interesting review comments for the papers
* [Papers with code](https://paperswithcode.com/), it highlights trending ML research and the code to implement it
* [Machine translation reading list](https://github.com/THUNLP-MT/MT-Reading-List), Tsinghua Natural Language Processing Group summarizes a list of paper list worth to read
* [Graph Neural Networks(GNN) Papers](https://github.com/thunlp/GNNPapers), great paper list for graph neural networks

## Blogs/Website
* [NLP-progress](http://nlpprogress.com/) This website tracks the progress in Natural Language Processing (NLP), including the datasets and the current state-of-the-art for the most common NLP tasks
* [Sebastian Ruder's Blog](http://ruder.io/) This blog includes Machine Learning, Deep Learning, and NLP content.
* [Aminer.org](https://aminer.org/) The free online service used to index, search, and mine big scientific data. A very useful tool to explore the exports/researchers in specific domain.
* [deeplearning.net](http://deeplearning.net/) Deep learning collection
* [stateoftheart.ai](https://www.stateoftheart.ai/), collect the state of art tech about Artificial Intelligence (AI) and Machine Learning (ML)
* [Distill](https://distill.pub/), Latest articles about machine learning
* [Facebook AI Blog](https://research.fb.com/blog/)
* [Google AI blog](https://ai.googleblog.com/)
* [Open AI](https://openai.com/)
* [The Berkeley Artificial Intelligence Research Blog](https://bair.berkeley.edu/blog/)
* [Deep Mind Blog](https://deepmind.com/blog/)
* [Visualizing machine learning one concept at a time](https://jalammar.github.io/), very cool and interesting blogs which illustrates one concept in detail in each blog.
* https://explained.ai/
* [Deep Learning Monitor](https://deeplearn.org/), collects most recent topic about deep learning
* [deeplearning.ai](https://www.deeplearning.ai/)
* [Hugging Face](https://huggingface.co/)

## Measurement
* [AI Progress Measurement](https://www.eff.org/ai/metrics), the measurement about AI progress

## Dataset
- [Allen AI Data](https://allenai.org/data)
- [Hugging Face Datasets](https://huggingface.co/datasets)

## Resource Hub
* [Must-read Blogs for AI and Deep Learning Enthusiasts](https://blog.paralleldots.com/data-science/must-read-blogs-ai-deep-learning-enthusiasts/)
* [Tensorflow Course](https://github.com/machinelearningmindset/TensorFlow-Course)
* [Deep Learning Ocean](https://github.com/machinelearningmindset/deep-learning-ocean)


